/************************************************************************
 *									*
 *		nr^Q@IC[UT|[gVXe		*
 *			ob|mds^Q				*
 *									*
 *				: C				*
 *		t@C	: main.c				*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include "pcnet.h"
#include <stdlib.h>
#include <string.h>
#include <io.h>

#define	MAX_RECORD	9999

/*--------------------------------------*/
/*		֐		*/
/*--------------------------------------*/
static	BOOL	Initialize(VOID);
static	BOOL	CheckDiskSpace(VOID);
static	VOID	RegisterSwitchEntry(HWND);
static	VOID	GetDisplayValues(VOID);
static	BOOL	CreateLogDBF(VOID);
static	BOOL	UseLogIndex(BOOL);
static	VOID	MainWndCreate(HWND);
static	VOID	MainWndPaint(HWND);
static	VOID	MainWndInitMenu(HWND, USHORT);
static	VOID	MainWndCommand(HWND, USHORT);
static	VOID	ReadSelectData(LOGDATA *);
static	VOID	DeleteLogFile(HWND);
static	VOID	DeleteLog(HWND);
static	VOID	DeleteSaveFile(BOOL);
static	BOOL	PassWordCheck(HWND);
static	VOID	MainWndLogin(HWND, LOGIN *);
static	VOID	MainWndLogout(HWND, LOGOUT *);
static	VOID	MainWndVScroll(HWND, MPARAM, MPARAM);
static	VOID	Scroll(HWND, SHORT);
static	VOID	MainWndTimer(HWND, USHORT);
static	VOID	MainWndClose(VOID);
static	VOID	Mouse1Down(HWND, MPARAM);
static	VOID	Mouse1Up(VOID);
static	VOID	Mouse2Down(HWND);
static	VOID	MouseDragCheck(HWND);
static	VOID	SelectLines(HWND, SHORT, BOOL);
static	VOID	EnableScrollBar(HWND);
static	VOID	ISAMErrorProc(int);
MRESULT CALLBACK MainWindowProc(HWND, USHORT, MPARAM, MPARAM);
MRESULT CALLBACK PassWordDlg(HWND, USHORT, MPARAM, MPARAM);
MRESULT CALLBACK AboutDlg(HWND, USHORT, MPARAM, MPARAM);
static	VOID	TerminateHelp(HWND);
static	VOID	InitHelp(HWND, HAB);
static	VOID	SendHelpMsg(USHORT);
static	VOID	AssociateHelp(HWND);
static	VOID	DspHelpErr(CHAR *);

/*--------------------------------------*/
/*		ϐ		*/
/*--------------------------------------*/
static	HMQ	hmq;		/* bZ[WL[nh */
static	QMSG	qmsg;		/* bZ[W */
static	ULONG	flStyle =	/* t[EBhẼX^C */
	FCF_ACCELTABLE | FCF_TITLEBAR | FCF_SYSMENU | FCF_SIZEBORDER |
	FCF_MENU | FCF_MINMAX | FCF_ICON | FCF_VERTSCROLL;
static	HWND	hwndClient;	/* NCAgEBhEnh */
static	HWND	hwndSB;		/* XN[o[EBhEnh */
static	SHORT	pTop;		/* ʐM\擪|C^ */
static	SHORT	pTopSv;		/* O\擪R[h|C^ */
static	LONG	topRecNo;	/* \擪R[hԍ */
static	SHORT	pSelect;	/* ʐMIʒu|C^ */
static	SHORT	pSelect1;	/* ʐMIJnʒu|C^ */
static	SHORT	pSelect2;	/* ʐMIIʒu|C^ */
static	SHORT	nSelect;	/* ʐMI */
static	BOOL	selectFlag;	/* ʐMI𒆃tO */
static	LONG	selectRecNo;	/* I𕨗R[hԍ */
static	BOOL	opt_m;		/* eiX[htO */
static	SHORT	yMousePos;	/* }EXxW */
static	HWND hwndHelpInstance;

/*=======================================================================
 |
 |		C֐
 |
 |	void	main(argc, argv)
 |
 |		int	argc;		R}hp[^
 |		char	*argv[];	R}hp[^
 |
 =======================================================================*/
void	main(int argc, char *argv[])
{
	HSYSSEM	hSem;

	/* R}hp[^`FbN */
	while (--argc) {
		argv++;
		if (strcmp(*argv, "/M") == 0 || strcmp(*argv, "/m") == 0)
			opt_m = TRUE;	/* eiX[h */
		else
			exit(1);
	}

	/* ol̏ */
	if ((hab = WinInitialize(0)) == NULL)
		FatalError(ER_WinInitialine);

	/* bZ[WL[̍쐬 */
	if ((hmq = WinCreateMsgQueue(hab, DEFAULT_QUEUE_SIZE)) == NULL)
		FatalError(ER_WinCreateMsgQueue);

	/* ʏ̎擾 */
	GetDisplayValues();

	if (DosCreateSem(CSEM_PRIVATE, &hSem, "\\sem\\pc-net.sem") != 0) {
		/* ɂx|mdsNĂ */
		WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
			"łɋNĂ܂B",
			systemName,
			ID_MB,
			MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
		WinPostMsg(NULL, WM_QUIT, 0, 0);
	} else if (opt_m) {
		/* eiX[h */
		hwndMain = WinLoadDlg(HWND_DESKTOP, HWND_DESKTOP,
					 MaintenanceDlg, 0, IDD_MAINTE, NULL);
	} else {
		/* ʏ탂[h */
		if (Initialize() == FALSE)
			WinPostMsg(NULL, WM_QUIT, 0, 0);
	}

	InitHelp(hwndMain, hab);

	/* bZ[W[v */
	while (WinGetMsg(hab, (PQMSG)&qmsg, (HWND)NULL, 0, 0))
		WinDispatchMsg(hab, (PQMSG)&qmsg);

	/* I */
	TerminateHelp(hwndMain);
	if (hwndMain != NULL)
		WinDestroyWindow(hwndMain);
	WinDestroyMsgQueue(hmq);
	WinTerminate(hab);
	Terminate();

	DosExit(EXIT_PROCESS, 0);
}

/*=======================================================================
 |
 |		
 |
 |	BOOL	Initialize()
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEF~
 |
 =======================================================================*/
static	BOOL	Initialize(VOID)
{
	static	VOID (FAR *thread[4])() = {
		Ch0Thread, Ch1Thread, Ch2Thread, Ch3Thread
	};
	PBYTE	stackPtr;
	SHORT	i;
	FILE	*fp;
	BOOL	fIndexCreate;

	/* CEBhENX̓o^ */
	if (!WinRegisterClass(hab, (PCH)szMainClassName,
					(PFNWP)MainWindowProc, 0, 0))
		FatalError(ER_WinRegisterClass);

	/* [UǗEBhENX̓o^ */
	if (!WinRegisterClass(hab, (PCH)szUserClassName,
					(PFNWP)UserWindowProc, 0, 0))
		FatalError(ER_WinRegisterClass);

	/* fǗEBhENX̓o^ */
	if (!WinRegisterClass(hab, (PCH)szBBSClassName,
					(PFNWP)BBSWindowProc, 0, 0))
		FatalError(ER_WinRegisterClass);

	/* [ǗEBhENX̓o^ */
	if (!WinRegisterClass(hab, (PCH)szMailClassName,
					(PFNWP)MailWindowProc, 0, 0))
		FatalError(ER_WinRegisterClass);

	/* j^[EBhENX̓o^ */
	if (!WinRegisterClass(hab, (PCH)szMonitorClassName,
		(PFNWP)MonitorWindowProc, CS_SIZEREDRAW, sizeof(ULONG)))
		FatalError(ER_WinRegisterClass);

	/* ^[~iEBhENX̓o^ */
	if (!WinRegisterClass(hab, (PCH)szTerminalClassName,
			(PFNWP)TermWindowProc, CS_SIZEREDRAW, sizeof(ULONG)))
		FatalError(ER_WinRegisterClass);

	/* hr`lCuG[nhݒ */
	DBErrHandler(ISAMErrorProc);

	/* ݒt@C̓ǂݍ */
	ReadEnvData();

	/* cfBXNeʃ`FbN */
	if (CheckDiskSpace() == FALSE)
		return(FALSE);

	/* ُI`FbN */
	if (access(fnFCHECK, 0) == 0) {
		fIndexCreate = TRUE;
	} else {
		fIndexCreate = FALSE;
		if ((fp = fopen(fnFCHECK, "w")) != NULL)
			fclose(fp);
	}

	/* `t@C̓ǂݍ */
	if (ReadOperationFile() == FALSE)
		return(FALSE);

	/* ʐMt@C̃I[v */
	if (OpenLogDBF(fIndexCreate) == FALSE)
		return(FALSE);

	/* [UǗt@C̃I[v */
	if (OpenUserDBF(fIndexCreate) == FALSE)
		return(FALSE);

	/* ̔t@C̃I[v */
	if (OpenSalesDBF(fIndexCreate) == FALSE)
		return(FALSE);

	/* fǗt@C̃I[v */
	if (OpenBBSMDBF(fIndexCreate) == FALSE)
		return(FALSE);

	/* [Ǘt@C̃I[v */
	if (OpenMailDBF(fIndexCreate) == FALSE)
		return(FALSE);

	/* CEBhE̍쐬 */
	if (!(hwndMain = WinCreateStdWindow(HWND_DESKTOP, WS_VISIBLE,
			&flStyle, szMainClassName, systemName, 0, 
			0, ID_RESOURCE_MAIN, &hwndClient)))
		FatalError(ER_WinCreateStdWindow);

	/* XN[o[EBhEnh̎擾 */
	hwndSB = WinWindowFromID(hwndMain, FID_VERTSCROLL);

	/* XCb`Ggւ̒ǉ */
	RegisterSwitchEntry(hwndMain);

	/* eXbh̋N */
	for (i = 0; i < 4; i++) {
		/* X^bNGAm */
		if ((stackPtr = malloc(STACKSIZE)) == NULL)
			FatalError(ER_malloc);

		stackPtr += STACKSIZE;

		/* Xbh̋N */
		if (DosCreateThread(thread[i],
					&threadID[i], stackPtr) != 0)
			FatalError(ER_DosCreateThread);

		/* vCIeB[̐ݒ */
		DosSetPrty(PRTYS_THREAD, PRTYC_REGULAR, 10, threadID[i]);
	}

	/* [M`FbN */
	CheckReceiveMail();

	/* t@C݃^C}[Zbg */
	WinStartTimer(hab, hwndClient, TMID_FLUSH, (USHORT)60000);

	return(TRUE);
}

/*=======================================================================
 |
 |		cfBXNeʃ`FbN
 |
 |	BOOL	CheckDiskSpace()
 |
 |		BOOL	Ԓl		TRUE Fc肠
 |					FALSEFcȂ
 |
 =======================================================================*/
static	BOOL	CheckDiskSpace(VOID)
{
	FSALLOCATE	fsAllocate;

	DosQFSInfo(0, 1, (PBYTE)&fsAllocate, sizeof(fsAllocate));

	if (fsAllocate.cSectorUnit * fsAllocate.cbSector *
					fsAllocate.cUnitAvail < 1024L*1024L) {
		if (WinMessageBox(HWND_DESKTOP, hwndMain,
				"s܂H",
				"fBXN̎ceʂsĂ܂B", ID_MB,
				MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL
				) != MBID_YES) {
			return(FALSE);
		}
	}
	return(TRUE);
}

/*=======================================================================
 |
 |		XCb`Ggւ̒ǉ
 |
 |	VOID	RegisterSwitchEntry(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	RegisterSwitchEntry(HWND hwnd)
{
	PID	pid;
	TID	tid;
	SWCNTRL	swc;

	WinQueryWindowProcess(hwnd, (PPID)&pid, (PTID)&tid);
	WinQueryWindowText(hwnd, MAXNAMEL, (PSZ)swc.szSwtitle);
	swc.hwnd = hwnd;
	swc.hwndIcon = (ULONG)NULL;
	swc.hprog = (HPROGRAM)NULL;
	swc.idProcess = pid;
	swc.idSession = 0;
	swc.uchVisibility = SWL_VISIBLE;
	swc.fbJump = SWL_JUMPABLE;
	WinAddSwitchEntry((PSWCNTRL)&swc);
}

/*=======================================================================
 |
 |		ʏ擾
 |
 |	VOID	GetDisplayValues()
 |
 =======================================================================*/
static	VOID	GetDisplayValues(VOID)
{
	HPS	hps;
	FONTMETRICS	fm;

	/* ʂ̑傫 */
	cxScreen = (SHORT)WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);
	cyScreen = (SHORT)WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN);

	hps = WinGetPS(HWND_DESKTOP);
	GpiQueryFontMetrics(hps, (ULONG)sizeof(FONTMETRICS), &fm);
	WinReleasePS(hps);

	/* ̍o*/
	gcyChar = (USHORT)(fm.lMaxBaselineExt + fm.lExternalLeading);

	/* ϕo */
	gcxAveChar = (USHORT)fm.lAveCharWidth;

	/* ő啶o */
	gcxMaxChar = (USHORT)fm.lMaxCharInc;
}

/*=======================================================================
 |
 |		ʐMt@CI[v
 |
 |	BOOL	OpenLogDBF(fIndexCreate)
 |
 |		BOOL	fIndexCreate;	CfbNXt@C쐬tO
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEFI[vs
 |
 =======================================================================*/
BOOL	OpenLogDBF(BOOL fIndexCreate)
{
	if ((logDBp = DBOpen(fnLOGDBF)) == NULL) {
		if (WinMessageBox(HWND_DESKTOP, hwndMain,
				"VKɍ쐬܂H",
				"ʐMt@C܂I", ID_MB,
				MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL
				) == MBID_YES) {
			DosMkDir(dnLOGFILE, 0L);
			return(CreateLogDBF());	/* VK쐬 */
		} else
			return(FALSE);
	} else {
		if (DBCheckSize(logDBp))
			fIndexCreate = TRUE;
	}

	if (UseLogIndex(fIndexCreate) == FALSE) {
		DBClose(logDBp);
		return(FALSE);
	}

	return(TRUE);
}

/*=======================================================================
 |
 |		ʐMt@CVK쐬
 |
 |	BOOL	CreateLogDBF()
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEF쐬s
 |
 =======================================================================*/
static	BOOL	CreateLogDBF(VOID)
{
	static	DBF_I	fieldData[] = { /* ʐMt@CtB[hf[^ */
		{"`lNo", 'C',  1, 0},
		{"[Uhc", 'C',  8, 0},
		{"Jnt",   'C',  8, 0},
		{"Jn",   'C',  8, 0},
		{"I",   'C',  8, 0},
		{"gp",   'C',  8, 0},
		{"t@C", 'C', 12, 0}
	};

	if ((logDBp = DBCreate(fnLOGDBF, fieldData,
				sizeof(fieldData)/sizeof(DBF_I))) == NULL) {
		WinMessageBox(HWND_DESKTOP, hwndMain,
				"ʐMt@CI[vł܂łB",
				"t@CANZXG[I",
				ID_MB,
				MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
		return(FALSE);
	}

	if (UseLogIndex(TRUE) == FALSE) {
		DBClose(logDBp);
		return(FALSE);
	}

	return(TRUE);
}

/*=======================================================================
 |
 |		CfbNXt@CI[v^쐬
 |
 |	BOOL	UseLogIndex(fCreate)
 |
 |		BOOL	fCreate;	쐬tO
 |
 |		BOOL	Ԓl		TRUE F
 |					FALSEF쐬s
 |
 =======================================================================*/
static	BOOL	UseLogIndex(BOOL fCreate)
{
	if (fCreate || DBIndex(logDBp, fnLOGNDX) == 0) {
		if (DBIdxCreate(logDBp, fnLOGNDX,
					"Jnt+Jn", 0) == 0) {
			WinMessageBox(HWND_DESKTOP, hwndMain,
				"CfbNXt@C쐬ł܂łB",
				"ʐMt@CANZXG[I",
				ID_MB,
				MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
			return(FALSE);
		}
	}

	return(TRUE);
}

/*=======================================================================
 |
 |		CEBhEvV[W
 |
 |	MRESULT CALLBACK MainWindowProc(hwnd, msg, mp1, mp2)
 |
 |		HWND	hwnd;		EBhEnh
 |		USHORT	msg;		bZ[Wʎq
 |		MPARAM	mp1;		bZ[Wp[^P
 |		MPARAM	mp2;		bZ[Wp[^Q
 |
 =======================================================================*/
MRESULT CALLBACK MainWindowProc(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
	static	BOOL	mailFlag;

	switch (msg) {
	case WM_CREATE:
		MainWndCreate(hwnd);
		return(FALSE);
	case WM_PAINT:
		MainWndPaint(hwnd);
		return(0);
	case WM_INITMENU:
		MainWndInitMenu(hwnd, SHORT1FROMMP(mp1));
		return(0);
	case WM_COMMAND:
		MainWndCommand(hwnd, SHORT1FROMMP(mp1));
		return(0);
	case WM_SIZE:
		EnableScrollBar(hwnd);
		break;
	case WM_VSCROLL:
		MainWndVScroll(hwnd, mp1, mp2);
		return(0);
	case WM_BUTTON1DOWN:
		Mouse1Down(hwnd, mp1);
		break;
	case WM_BUTTON1UP:
		Mouse1Up();
		break;
	case WM_BUTTON1DBLCLK:
		if (nSelect == 1)
			WinPostMsg(hwnd, WM_COMMAND,
					MPFROMSHORT(IDM_MAIN_FILE_LOGDISP), 0);
		break;
	case WM_BUTTON2DOWN:
		Mouse2Down(hwnd);
		break;
	case WM_MOUSEMOVE:
		yMousePos = SHORT2FROMMP(mp1);
		MouseDragCheck(hwnd);
		break;
	case WM_TIMER:
		MainWndTimer(hwnd, SHORT1FROMMP(mp1));
		return(0);
	case WM_CLOSE:
		if (PassWordCheck(hwnd))	/* Ǘ҃pX[h`FbN */
			MainWndClose();
		return(0);
	case WM_USER_LOGIN:		/* OCʒm */
		MainWndLogin(hwnd, (LOGIN *)mp1);
		return(0);
	case WM_USER_LOGOUT:		/* OAEgʒm */
		MainWndLogout(hwnd, (LOGOUT *)mp1);
		return(0);
	case WM_USER_MSGBOX:		/* bZ[W{bNXI[v */
		WinMessageBox(HWND_DESKTOP, hwnd, mp1, mp2,
						ID_MB, MB_NOICON | MB_OK);
		return(0);
	case WM_USER_MAIL:		/* [Mʒm */
		WinAlxxx(HWND_DESKTOP, WA_NOTE);
		if (mailFlag == FALSE) {
			mailFlag = TRUE;
			WinMessageBox(HWND_DESKTOP, hwndMain,
				"[Ă܂B",
				"m@F", ID_MB,
				MB_OK | MB_ICONASTERISK | MB_APPLMODAL);
			mailFlag = FALSE;
		}
		return(0);
	case HM_QUERY_KEYS_HELP:
		return(MRFROMSHORT(KEYS_HELP_HP));
	}

	return(WinDefWindowProc(hwnd, msg, mp1, mp2));
}

/*=======================================================================
 |
 |		CEBhE쐬
 |
 |	VOID	MainWndCreate(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	MainWndCreate(HWND hwnd)
{
	HWND	hwndFrame;

	/* EBhËʒuƑ傫̐ݒ */
	hwndFrame = WinQueryWindow(hwnd, QW_PARENT, FALSE);
	SetWindowPos(hwndFrame, 67, 12);

	pTop = 0;		/* ʐM\擪|C^ */
	nSelect = 0;		/* ʐMI𐔏 */
}

/*=======================================================================
 |
 |		CEBhE`揈
 |
 |	VOID	MainWndPaint(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	MainWndPaint(HWND hwnd)
{
	static	CHAR	msg[] =
	"  m. bg  [Uhc  Jnt  Jn  I  ʐM";
	HPS	hps;
	RECTL	rcl;
	POINTL	pt;
	SHORT	pCurrent;
	SHORT	top, bottom;
	SHORT	nRec;
	LOGDATA	logBuf;
	CHAR	strBuf[80];

	/* XN[o[\ */
	EnableScrollBar(hwnd);

	hps = WinBeginPaint(hwnd, NULL, &rcl);
	WinFillRect(hps, &rcl, SYSCLR_WINDOW);
	top = (SHORT)rcl.yTop;
	bottom = (SHORT)rcl.yBottom;

	WinQueryWindowRect(hwnd, &rcl);
	pt.x = 0;
	pt.y = rcl.yTop - gcyChar - gcyChar / 2;
	if (pt.y < top) {
		GpiSetColor(hps, SYSCLR_WINDOWSTATICTEXT);
		GpiCharStringAt(hps, &pt, (LONG)strlen(msg), msg);
		GpiSetColor(hps, SYSCLR_WINDOWTEXT);
	}
	pt.y = rcl.yTop - gcyChar * 3;

	/* ʐM̕\ */
	if (pTop == 0 || topRecNo == 0 || DBCheckUpdate(logDBp)) {
		DBBottom(logDBp);
		DBSkip(logDBp, -pTop);
		topRecNo = DBRecNo(logDBp);
		DBResetUpdate(logDBp);
	} else {
		DBSet(logDBp, topRecNo);
		if (pTop != pTopSv) {
			DBSkip(logDBp, pTopSv - pTop);
			topRecNo = DBRecNo(logDBp);
		}
	}
	pTopSv = pTop;

	nRec = (SHORT)DBRecCount(logDBp);
	for (pCurrent = pTop; ;pCurrent++) {
		if (DBBof(logDBp))	/* t@C̐擪ȂI */
			break;

		/* Is̃R[hԍ擾 */
		if (nSelect != 0 && pCurrent == pSelect)
			selectRecNo = DBRecNo(logDBp);

		/* ŉ[܂ŕ\I */
		if (pt.y + gcyChar <= bottom || pt.y + gcyChar < 0)
			break;

		/* ʐMf[^̕\ */
		if (pt.y < top) {
			DBRead(logDBp, &logBuf);
			sprintf(strBuf,
			"  %4d   CH%c   %.8s   %.8s  %.8s  %.8s  %.8s %c",
				nRec - pCurrent,
				logBuf.chNo[0],
				logBuf.userID,
				logBuf.loginDate,
				logBuf.loginTime,
				logBuf.logoutTime,
				logBuf.usedTime,
				logBuf.fileName[0] != ' ' ? '*' : ' ');
			GpiCharStringAt(hps, &pt, (LONG)strlen(strBuf),
								 strBuf);

			/* Iڂ̔] */
			if (pCurrent >= pSelect && pCurrent < pSelect+nSelect){
				rcl.yTop = pt.y + gcyChar;
				rcl.yBottom = pt.y;
				WinInvertRect(hps, &rcl);
			}
		}

		pt.y -= gcyChar;	/* \ʒuXV */

		DBSkip(logDBp, -1L);	/* R[h */
	}

	WinEndPaint(hps);

	MouseDragCheck(hwnd);		/* }EXhbO`FbN */
}

/*=======================================================================
 |
 |		CEBhE@j[
 |
 |	VOID	MainWndInitMenu(hwnd, menuID)
 |
 |		HWND	hwnd;		EBhEnh
 |		USHORT	menuID;		j[hc
 |
 =======================================================================*/
static	VOID	MainWndInitMenu(HWND hwnd, USHORT menuID)
{
	static	USHORT	monitorID[3] = {
		IDM_MAIN_MON_CH1, IDM_MAIN_MON_CH2, IDM_MAIN_MON_CH3
	};
	static	USHORT	terminalID[4] = {
		IDM_MAIN_TERM_CH0, IDM_MAIN_TERM_CH1,
		IDM_MAIN_TERM_CH2, IDM_MAIN_TERM_CH3
	};
	SHORT	i;
	USHORT	chNo;
	LOGDATA	logBuf;
	BOOL	logFileFlag;

	switch (menuID) {
	case IDM_MAIN_FILE:
		WinSendDlgItemMsg(hwndMain, FID_MENU, MM_SETITEMATTR,
			MPFROM2SHORT(IDM_MAIN_FILE_USERINF, TRUE),
			MPFROM2SHORT(MIA_DISABLED,
			(nSelect == 1 ? 0 : MIA_DISABLED)));

		logFileFlag = FALSE;
		if (nSelect == 1) {
			ReadSelectData(&logBuf);
			if (logBuf.fileName[0] != ' ')
				logFileFlag = TRUE;
		}
		WinSendDlgItemMsg(hwndMain, FID_MENU, MM_SETITEMATTR,
			MPFROM2SHORT(IDM_MAIN_FILE_LOGDISP, TRUE),
			MPFROM2SHORT(MIA_DISABLED,
			(logFileFlag ? 0 : MIA_DISABLED)));

		WinSendDlgItemMsg(hwndMain, FID_MENU, MM_SETITEMATTR,
			MPFROM2SHORT(IDM_MAIN_FILE_LOGFDEL, TRUE),
			MPFROM2SHORT(MIA_DISABLED,
			(nSelect != 0 ? 0 : MIA_DISABLED)));
		WinSendDlgItemMsg(hwndMain, FID_MENU, MM_SETITEMATTR,
			MPFROM2SHORT(IDM_MAIN_FILE_LOGDEL, TRUE),
			MPFROM2SHORT(MIA_DISABLED,
			(nSelect != 0 ? 0 : MIA_DISABLED)));
		break;
	case IDM_MAIN_MONITOR:
		for (i = 0, chNo = CH1; i < 3; i++, chNo++) {
			WinSendDlgItemMsg(hwndMain, FID_MENU, MM_SETITEMATTR,
				MPFROM2SHORT(monitorID[i], TRUE),
				MPFROM2SHORT(MIA_DISABLED | MIA_CHECKED,
				(portOpenFlag[chNo] ? 0 : MIA_DISABLED) |
				(monitorFlag[chNo] ? MIA_CHECKED : 0)));
		}
		break;
	case IDM_MAIN_TERMINAL:
		for (i = 0, chNo = CH0; i < 4; i++, chNo++) {
			WinSendDlgItemMsg(hwndMain, FID_MENU, MM_SETITEMATTR,
				MPFROM2SHORT(terminalID[i], TRUE),
				MPFROM2SHORT(MIA_DISABLED | MIA_CHECKED,
				(portOpenFlag[chNo] ? 0 : MIA_DISABLED) |
				(terminalMode[chNo]  & TMODE_TERMINAL ?
				MIA_CHECKED : 0)));
		}
		break;
	}
}

/*=======================================================================
 |
 |		CEBhE@R}h
 |
 |	VOID	MainWndCommand(hwnd, command)
 |
 |		HWND	hwnd;		EBhEnh
 |		USHORT	command;	R}hhc
 |
 =======================================================================*/
static	VOID	MainWndCommand(HWND hwnd, USHORT command)
{
	LOGDATA	logBuf;		/* ʐMt@Cobt@ */
	CHAR	fileName[13];	/* t@C */
	CHAR	pathName[26];	/* pX */

	if (command != IDM_ABOUT && command != IDM_EXIT) {
		/* Ǘ҃pX[h`FbN */
		if (PassWordCheck(hwnd) == FALSE)
			return;
	}

	switch (command) {
	case IDM_MAIN_FILE_USER:	/* [UǗ */
		UserManagement();
		break;
	case IDM_MAIN_FILE_BBS:		/* fǗ */
		BBSManagement();
		break;
	case IDM_MAIN_FILE_MAIL:	/* [Ǘ */
		MailManagement();
		break;
	case IDM_MAIN_FILE_USERINF:	/* [U\ */
		ReadSelectData(&logBuf);
		WinDlgBox(HWND_DESKTOP, hwnd, UserDlg,
					0, IDD_USER, logBuf.userID);
		break;
	case IDM_MAIN_FILE_LOGDISP:	/* ʐMe\ */
		ReadSelectData(&logBuf);
		if (logBuf.fileName[0] != ' ' && logBuf.logoutTime[0] != '*') {
			CopyFromDBF(fileName, logBuf.fileName,
					sizeof(logBuf.fileName));
			sprintf(pathName, "%s\\%s", dnLOGFILE, fileName);
			if (access(pathName, 0) == 0)
				ExecEditor(pathName);
		}
		break;
	case IDM_MAIN_FILE_LOGFDEL:	/* ʐMe폜 */
		DeleteLogFile(hwnd);
		break;
	case IDM_MAIN_FILE_LOGDEL:	/* ʐM폜 */
		DeleteLog(hwnd);
		break;
	case IDM_ABOUT:		/* vtB[ */
		WinDlgBox(HWND_DESKTOP, hwnd, AboutDlg,
						0, IDD_ABOUT, NULL);
		break;
	case IDM_MAIN_SET_PORT:	/* ʐM|[gݒ */
		WinDlgBox(HWND_DESKTOP, hwnd, SetPortDlg,
						0, IDD_PORT, NULL);
		break;
	case IDM_MAIN_SET_ENV:	/* ݒ */
		WinDlgBox(HWND_DESKTOP, hwnd, SetEnvDlg,
						0, IDD_ENV, NULL);
		break;
	case IDM_MAIN_SET_CMSG:	/* ڑbZ[W */
		ExecEditor(fnConxxxtMsg);
		break;
	case IDM_MAIN_SET_LMSG:	/* OCbZ[W */
		ExecEditor(fnLoginMsg);
		break;
	case IDM_MAIN_MON_CH1:	/* `lPj^[ */
		Monitor(CH1);
		break;
	case IDM_MAIN_MON_CH2:	/* `lQj^[ */
		Monitor(CH2);
		break;
	case IDM_MAIN_MON_CH3:	/* `lRj^[ */
		Monitor(CH3);
		break;
	case IDM_MAIN_TERM_CH0:	/* [J^[~i */
		Terminal(CH0);
		break;
	case IDM_MAIN_TERM_CH1:	/* `lP^[~i */
		Terminal(CH1);
		break;
	case IDM_MAIN_TERM_CH2:	/* `lQ^[~i */
		Terminal(CH2);
		break;
	case IDM_MAIN_TERM_CH3:	/* `lR^[~i */
		Terminal(CH3);
		break;
	case IDM_MAIN_HELP_HELP:
		SendHelpMsg(HM_DISPLAY_HELP);
		break;
	case IDM_MAIN_HELP_EXT:
		SendHelpMsg(HM_EXT_HELP);
		break;
	case IDM_MAIN_HELP_INDEX:
		SendHelpMsg(HM_HELP_INDEX);
		break;
	case IDM_MAIN_HELP_KEYS:
		SendHelpMsg(HM_KEYS_HELP);
		break;
	case IDM_EXIT:		/* I */
		WinPostMsg(hwnd, WM_CLOSE, 0, 0);
		break;
	case IDK_LINEUP:
		Scroll(hwnd, -1);
		break;
	case IDK_LINEDOWN:
		Scroll(hwnd, 1);
		break;
	case IDK_PAGEUP:
		Scroll(hwnd, PAGE_UP);
		break;
	case IDK_PAGEDOWN:
		Scroll(hwnd, PAGE_DOWN);
		break;
	case IDK_UP:
		SelectLines(hwnd, -1, FALSE);
		break;
	case IDK_DOWN:
		SelectLines(hwnd, 1, FALSE);
		break;
	case IDK_DRAG_UP:
		SelectLines(hwnd, -1, TRUE);
		break;
	case IDK_DRAG_DOWN:
		SelectLines(hwnd, 1, TRUE);
		break;
	case IDK_CANCEL:
		SelectLines(hwnd, 0, FALSE);
		break;
	}
}

/*=======================================================================
 |
 |		I𒆒ʐMf[^ǂݍݏ
 |
 |	VOID	ReadSelectData(logBufp)
 |
 |		LOGDATA	*logBufp;	ʐMf[^obt@
 |
 =======================================================================*/
static	VOID	ReadSelectData(LOGDATA *logBufp)
{
	DBSet(logDBp, selectRecNo);
	DBRead(logDBp, logBufp);
}

/*=======================================================================
 |
 |		ʐMeۑt@C폜
 |
 |	VOID	DeleteLogFile(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	DeleteLogFile(HWND hwnd)
{
	SHORT	i;

	if (WinMessageBox(HWND_DESKTOP, hwnd,
			"w肵ʐMe폜܂H",
			"m@F", ID_MB,
			MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL)
			== MBID_NO) {
		return;
	}

	SetPointer(SPTR_WAIT);

	DBSet(logDBp, selectRecNo);
	for (i = 0; i < nSelect; i++) {
		if (DBBof(logDBp))
			break;
		DeleteSaveFile(TRUE);
		DBSkip(logDBp, -1L);
	}

	SetPointer(SPTR_ARROW);

	WinInvalidateRect(hwnd, NULL, FALSE);
}

/*=======================================================================
 |
 |		ʐM폜
 |
 |	VOID	DeleteLog(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	DeleteLog(HWND hwnd)
{
	SHORT	i;
	SHORT	nRec;

	if (WinMessageBox(HWND_DESKTOP, hwnd,
			"w肵ʐM폜܂H",
			"m@F", ID_MB,
			MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL)
			== MBID_NO) {
		return;
	}

	SetPointer(SPTR_WAIT);

	DBSet(logDBp, selectRecNo);
	if (nSelect < (SHORT)DBRecCount(logDBp) / 5) {
		for (i = 0; i < nSelect; i++) {
			if (DBBof(logDBp))
				break;
			DeleteSaveFile(FALSE);
			DBDelete4(logDBp);
		}
	} else {
		for (i = 0; i < nSelect; i++) {
			if (DBBof(logDBp))
				break;
			DeleteSaveFile(FALSE);
			DBDelete(logDBp);
			DBSkip(logDBp, -1L);
		}
		DBPack(logDBp);
	}

	nRec = (SHORT)DBRecCount(logDBp);
	if (pTop >= nRec)
		pTop = (nRec != 0) ? nRec - 1 : 0;

	if (pTop > pSelect)
		pTop = pSelect;

	SetPointer(SPTR_ARROW);

	nSelect = 0;
	WinInvalidateRect(hwnd, NULL, FALSE);
}

/*=======================================================================
 |
 |		ʐMeۑt@C폜
 |
 |	VOID	DeleteSaveFile(fUpdate)
 |
 |		BOOL	fUpdate;	ۑ}[N폜
 |
 =======================================================================*/
static	VOID	DeleteSaveFile(BOOL fUpdate)
{
	LOGDATA	logBuf;
	CHAR	fileName[13], pathName[26];

	DBRead(logDBp, &logBuf);
	if (logBuf.fileName[0] != ' ') {
		CopyFromDBF(fileName, logBuf.fileName,
					sizeof(logBuf.fileName));
		sprintf(pathName, "%s\\%s", dnLOGFILE, fileName);
		DosDelete(pathName, 0L);
		if (fUpdate) {
			memset(logBuf.fileName, ' ', 12);
			DBUpdate(logDBp, &logBuf);
		}
	}
}

/*=======================================================================
 |
 |		Ǘ҃pX[h͏
 |
 |	BOOL	PassWordCheck(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 |		BOOL	Ԓl		TRUE FpX[h͂nj
 |					FALSEFpX[h͂mfi~jP
 |
 =======================================================================*/
static	BOOL	PassWordCheck(HWND hwnd)
{
	if (sv.env.passWord[0] != '\0') {
		if (WinDlgBox(HWND_DESKTOP, hwnd, PassWordDlg,
					0, IDD_PASSWORD, NULL) != DID_OK)
			return(FALSE);
	}
	return(TRUE);
}

/*=======================================================================
 |
 |		pX[h̓EBhEvV[W
 |
 |	MRESULT CALLBACK PassWordDlg(hwnd, msg, mp1, mp2)
 |
 |		HWND	hwnd;		EBhEnh
 |		USHORT	msg;		bZ[Wʎq
 |		MPARAM	mp1;		bZ[Wp[^P
 |		MPARAM	mp2;		bZ[Wp[^Q
 |
 =======================================================================*/
MRESULT CALLBACK PassWordDlg(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
	CHAR	passWord[9], *p;

	switch (msg) {
	case WM_INITDLG:
		WinSendDlgItemMsg(hwnd, IDD_PWD_PASSWD,
				EM_SETTEXTLIMIT, MPFROMSHORT(8), 0);
		CenterDlgBox(hwnd);
		break;
	case WM_COMMAND:
		switch(SHORT1FROMMP(mp1)) {
		case DID_OK:
			WinQueryDlgItemText(hwnd, IDD_PWD_PASSWD,
						sizeof(passWord), passWord);
			if (strcmp(passWord, sv.env.passWord) != 0) {
				WinMessageBox(HWND_DESKTOP, hwnd,
				"pX[hႢ܂B",
				"",
				ID_MB,
				MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL);
				WinSetFocus(HWND_DESKTOP,
				WinWindowFromID(hwnd, IDD_PWD_PASSWD));
				return(0);
			}
			break;
		case DID_CANCEL:
			break;
		}
		break;
	case WM_CONTROL:
		switch (SHORT1FROMMP(mp1)) {
		case IDD_PWD_PASSWD:
			switch (SHORT2FROMMP(mp1)) {
			case EN_CHANGE:
				WinQueryDlgItemText(hwnd, IDD_PWD_PASSWD,
					sizeof(passWord), passWord);
				for (p = passWord; *p != '\0'; p++)
					*p = '*';
				WinSetDlgItemText(hwnd,
					IDD_PWD_PASSWD2, passWord);
				return(0);
			}
		}
		break;
	}
	return(WinDefDlgProc(hwnd, msg, mp1, mp2));
}

/*=======================================================================
 |
 |		OCbZ[W
 |
 |	VOID	MainWndLogin(hwnd, mp)
 |
 |		HWND	hwnd;		EBhEnh
 |		LOGIN	*mp;		OCf[^|C^
 |
 =======================================================================*/
static	VOID	MainWndLogin(HWND hwnd, LOGIN *mp)
{
	RECTL	rcl;
	LOGDATA	logBuf;
	CHAR	strBuf[9];

	/* ʐMt@Cɏ */
	logBuf.chNo[0] = (CHAR)(mp->chNo + '0');
	CopyToDBF(logBuf.userID, mp->userID, sizeof(logBuf.userID));
	sprintf(strBuf, "%2u/%02u/%02u", mp->loginDate.year % 100,
			mp->loginDate.month, mp->loginDate.day);
	memcpy(logBuf.loginDate, strBuf, 8);
	sprintf(strBuf, "%2u:%02u:%02u", mp->loginTime.hour,
			mp->loginTime.minutes, mp->loginTime.seconds);
	memcpy(logBuf.loginTime, strBuf, 8);
	memset(logBuf.logoutTime, '*', 8);
	memset(logBuf.usedTime, '*', 8);
	CopyToDBF(logBuf.fileName, mp->logFile, sizeof(logBuf.fileName));
	DBStore(logDBp, &logBuf);

	/* EBhEXV */
	if (DBRecCount(logDBp) > MAX_RECORD) {
		DBTop(logDBp);
		DeleteSaveFile(FALSE);
		DBDelete2(logDBp);
		nSelect = 0;
		WinInvalidateRect(hwnd, NULL, FALSE);
	} else {
		if (pTop == 0) {
			WinQueryWindowRect(hwnd, &rcl);
			rcl.yTop -= gcyChar * 2;
			if (rcl.yTop < 0)
				rcl.yTop = 0;
			WinScrollWindow(hwnd, 0, -gcyChar, 0L, &rcl,
						NULL, NULL, SW_INVALIDATERGN);
		} else
			pTop++;

		if (nSelect != 0)
			pSelect++;
	}

	EnableScrollBar(hwnd);

	free(mp);
}

/*=======================================================================
 |
 |		OAEgbZ[W
 |
 |	VOID	MainWndLogout(hwnd, mp)
 |
 |		HWND	hwnd;		EBhEnh
 |		LOGOUT	*mp;		OAEgf[^|C^
 |
 =======================================================================*/
static	VOID	MainWndLogout(HWND hwnd, LOGOUT *mp)
{
	RECTL	rcl;
	LOGDATA	logBuf;
	SHORT	i;
	BOOL	updateFlag;
	CHAR	strBuf[9];

	updateFlag = FALSE;
	DBBottom(logDBp);
	for (i = 0; ; i++) {
		if (DBBof(logDBp))
			break;
		DBRead(logDBp, &logBuf);
		if (logBuf.chNo[0] == (CHAR)(mp->chNo + '0')) {
			if (logBuf.logoutTime[0] != '*')
				break;

			/* ʐMt@CXV */
			sprintf(strBuf, "%2u:%02u:%02u",
					mp->logoutTime.hour,
					mp->logoutTime.minutes,
					mp->logoutTime.seconds);
			memcpy(logBuf.logoutTime, strBuf, 8);
			sprintf(strBuf, "%2u:%02u:%02u",
					(SHORT)(mp->usedTime / 3600),
					(SHORT)(mp->usedTime / 60 % 60),
					(SHORT)(mp->usedTime % 60));
			memcpy(logBuf.usedTime, strBuf, 8);
			DBUpdate(logDBp, &logBuf);
			updateFlag = TRUE;
			break;
		}
		DBSkip(logDBp, -1L);
	}
	if (updateFlag) {
		/* EBhEXV */
		WinQueryWindowRect(hwnd, &rcl);
		rcl.yTop -= gcyChar * 2;
		if (i >= pTop && i <= pTop +
				(SHORT)(rcl.yTop - rcl.yBottom) / gcyChar) {
			rcl.yTop -= (i - pTop) * gcyChar;
			rcl.yBottom = rcl.yTop - gcyChar;
			WinInvalidateRect(hwnd, &rcl, FALSE);
		}
	}
	free(mp);
}

/*=======================================================================
 |
 |		CEBhE@XN[R}h
 |
 |	VOID	MainWndVScroll(hwnd, mp1, mp2)
 |
 |		HWND	hwnd;		EBhEnh
 |		MPARAM	mp1;		bZ[Wp[^P
 |		MPARAM	mp2;		bZ[Wp[^Q
 |
 =======================================================================*/
static	VOID	MainWndVScroll(HWND hwnd, MPARAM mp1, MPARAM mp2)
{
	switch (SHORT2FROMMP(mp2)) {
	case SB_LINEUP:
		Scroll(hwnd, -1);
		break;
	case SB_LINEDOWN:
		Scroll(hwnd, 1);
		break;
	case SB_PAGEUP:
		Scroll(hwnd, PAGE_UP);
		break;
	case SB_PAGEDOWN:
		Scroll(hwnd, PAGE_DOWN);
		break;
	case SB_SLIDERTRACK:
	case SB_SLIDERPOSITION:
		Scroll(hwnd, SHORT1FROMMP(mp2) - pTop);
		break;
	}
}

/*=======================================================================
 |
 |		CEBhE@XN[
 |
 |	VOID	Scroll(hwnd, n)
 |
 |		HWND	hwnd;		EBhEnh
 |		SHORT	n;		XN[s
 |
 =======================================================================*/
static	VOID	Scroll(HWND hwnd, SHORT n)
{
	RECTL	rcl;
	SHORT	pageLine;
	SHORT	nRec;

	WinQueryWindowRect(hwnd, &rcl);
	rcl.yTop -= gcyChar * 2;
	pageLine = (SHORT)(rcl.yTop - rcl.yBottom) / gcyChar;

	if (n == PAGE_UP)
		n = -pageLine;
	else if (n == PAGE_DOWN)
		n = pageLine;

	if (pTop + n < 0)
		n = -pTop;
	else {
		nRec = (SHORT)DBRecCount(logDBp);
		if (pTop + n >= nRec)
			n = nRec - pTop - 1;
	}

	if (n == 0)
		return;

	pTop += n;
	if ((n < 0 ? -n : n) < pageLine)
		WinScrollWindow(hwnd, 0, n * gcyChar, 0L, &rcl,
					NULL, NULL, SW_INVALIDATERGN);
	else
		WinInvalidateRect(hwnd, &rcl, FALSE);
}

/*=======================================================================
 |
 |		CEBhE ^C}[
 |
 |	VOID	MainWndTimer(hwnd, timerID)
 |
 |		HWND	hwnd;		EBhEnh
 |		USHORT	timerID;	^C}[hc
 |
 =======================================================================*/
static	VOID	MainWndTimer(HWND hwnd, USHORT timerID)
{
	BOOL	flag;
	SHORT	i;

	switch (timerID) {
	case TMID_FLUSH:
		DBFlushAll();
		break;
	case TMID_CLOSE:
		for (i = 0, flag = FALSE; i < N_CHANNEL; i++)
			flag |= conxxxtFlag[i];
		if (flag == FALSE)
			WinPostMsg(hwndMain, WM_QUIT, 0, 0);
		break;
	}
}

/*=======================================================================
 |
 |		CEBhE@N[Y
 |
 |	VOID	MainWndClose()
 |
 =======================================================================*/
static	VOID	MainWndClose(VOID)
{
	PSZ	title, text;
	SHORT	i;
	BOOL	flag;
	USHORT	numBytes;

	/* ڑ̃`l邩ׂ */
	for (i = 0, flag = FALSE; i < N_CHANNEL; i++)
		flag |= conxxxtFlag[i];

	if (flag) {
		title = "ڑ̃`l܂";
		text = "ؒf܂H";
	} else {
		title = systemName;
		text = "vOI܂H";
	}

	if (WinMessageBox(HWND_DESKTOP, hwndMain,
			text, title, ID_MB,
			MB_YESNO | MB_CUAWARNING | MB_APPLMODAL)
			== MBID_YES) {
		if (flag) {
			/* ؒf */
			closeRequest = TRUE;
			DosWrite(ch0Hndl, "\xff", 1, &numBytes);
			WinStartTimer(hab, hwndClient, TMID_CLOSE, 1000);
			WinMessageBox(HWND_DESKTOP, hwndMain,
				"΂炭҂B",
				"ؒfł", ID_MB,
				MB_CANCEL | MB_ICONHAND | MB_APPLMODAL);
			WinStopTimer(hab, hwndClient, TMID_CLOSE);
			closeRequest = FALSE;
		} else
			WinPostMsg(hwndMain, WM_QUIT, 0, 0);
	}
}

/*=======================================================================
 |
 |		AoEg_CAOEBhEvV[W
 |
 |	MRESULT CALLBACK AboutDlg(hwnd, msg, mp1, mp2)
 |
 |		HWND	hwnd;		EBhEnh
 |		USHORT	msg;		bZ[Wʎq
 |		MPARAM	mp1;		bZ[Wp[^P
 |		MPARAM	mp2;		bZ[Wp[^Q
 |
 =======================================================================*/
MRESULT CALLBACK AboutDlg(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
	switch (msg) {
	case WM_INITDLG:
		CenterDlgBox(hwnd);
		break;
	case WM_SUBSTITUTESTRING:
		switch (SHORT1FROMMP(mp1)) {
		case 0:
			return((MRESULT)systemName);
		case 1:
			return((MRESULT)version);
		}
		break;
	case WM_COMMAND:
		switch(SHORT1FROMMP(mp1)) {
		case DID_OK:
			break;
		}
		break;
	}
	return(WinDefDlgProc(hwnd, msg, mp1, mp2));
}

/*=======================================================================
 |
 |		}EX{^NbN
 |
 |	VOID	Mouse1Down(hwnd, mp1)
 |
 |		HWND	hwnd;		EBhEnh
 |		MPARAM	mp1;		bZ[Wp[^P
 |
 =======================================================================*/
static	VOID	Mouse1Down(HWND hwnd, MPARAM mp1)
{
	RECTL	rcl, rcl2;
	SHORT	selectLine;

	WinQueryWindowRect(hwnd, &rcl);
	rcl.yTop -= gcyChar * 2;

	if (nSelect != 0) {
		rcl2 = rcl;
		rcl2.yTop -= (pSelect - pTop) * gcyChar;
		rcl2.yBottom = rcl2.yTop - nSelect * gcyChar;
		WinInvalidateRect(hwnd, &rcl2, FALSE);
		nSelect = 0;
	}

	selectLine = ((SHORT)rcl.yTop - (SHORT)SHORT2FROMMP(mp1)) / gcyChar;
	if (selectLine >= 0 && pTop + selectLine < (SHORT)DBRecCount(logDBp)) {
		nSelect = 1;
		pSelect = pTop + selectLine;
		rcl.yTop -= (pSelect - pTop) * gcyChar;
		rcl.yBottom = rcl.yTop - gcyChar;
		WinInvalidateRect(hwnd, &rcl, FALSE);
		if (WinSetCapture(HWND_DESKTOP, hwnd) == TRUE) {
			pSelect1 = pSelect2 = pSelect;
			selectFlag = TRUE;
		}

	}
}

/*=======================================================================
 |
 |		}EX{^J
 |
 |	VOID	Mouse1Up()
 |
 =======================================================================*/
static	VOID	Mouse1Up(VOID)
{
	if (selectFlag) {
		WinSetCapture(HWND_DESKTOP, NULL);
		selectFlag = FALSE;
	}
}

/*=======================================================================
 |
 |		}EX{^NbN
 |
 |	VOID	Mouse2Down(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	Mouse2Down(HWND hwnd)
{
	RECTL	rcl;

	if (nSelect != 0) {
		WinQueryWindowRect(hwnd, &rcl);
		rcl.yTop -= (2 + (pSelect - pTop)) * gcyChar;
		rcl.yBottom = rcl.yTop - nSelect * gcyChar;
		WinInvalidateRect(hwnd, &rcl, FALSE);
		nSelect = 0;
	}
}

/*=======================================================================
 |
 |		}EXhbO`FbN
 |
 |	VOID	MouseDragCheck(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	MouseDragCheck(HWND hwnd)
{
	RECTL	rcl, rcl2;
	SHORT	nScroll;
	SHORT	pCurrent;
	SHORT	pMin, pMax;

	if (selectFlag == FALSE)
		return;

	WinQueryWindowRect(hwnd, &rcl);
	rcl.yTop -= gcyChar * 2;

	pCurrent = pTop +
			((SHORT)rcl.yTop - yMousePos) / gcyChar;
	if (((SHORT)rcl.yTop - yMousePos) % gcyChar < 0)
		pCurrent--;

	if (pCurrent < 0)
		pCurrent = 0;
	else if (pCurrent >= (SHORT)DBRecCount(logDBp))
		pCurrent = (SHORT)DBRecCount(logDBp) - 1;

	if (pCurrent != pSelect2) {
		if (pCurrent >= pSelect1) {
			nSelect = pCurrent - pSelect1 + 1;
			pSelect = pSelect1;
		} else {
			nSelect = pSelect1 - pCurrent + 1;
			pSelect = pCurrent;
		}

		pMin = min(pCurrent, pSelect2);
		if (pMin >= pSelect1)
			pMin++;
		pMax = max(pCurrent, pSelect2);
		if (pMax > pSelect1)
			pMax++;
		rcl2 = rcl;
		rcl2.yTop = rcl.yTop - (pMin - pTop) * gcyChar;
		rcl2.yBottom = rcl.yTop - (pMax - pTop) * gcyChar;
		WinInvalidateRect(hwnd, &rcl2, FALSE);
		pSelect2 = pCurrent;

		if ((nScroll = pTop - pCurrent) > 0) {
			WinScrollWindow(hwnd, 0,
				-(nScroll * gcyChar), 0L,
				&rcl, NULL, NULL, SW_INVALIDATERGN);
			pTop -= nScroll;
		} else if ((nScroll = pCurrent -
				(pTop + (SHORT)rcl.yTop / gcyChar) + 1) > 0){
			WinScrollWindow(hwnd, 0,
				nScroll * gcyChar, 0L,
				&rcl, NULL, NULL, SW_INVALIDATERGN);
			pTop += nScroll;
		}
	}
}

/*=======================================================================
 |
 |		L[{[hɂsI
 |
 |	VOID	SelectLines(hwnd, n, drag)
 |
 |		HWND	hwnd;		EBhEnh
 |		SHORT	n;		|PFL[
 |					@PFL[
 |					@OFI
 |		BOOL	drag;		TRUE  : I
 |					FALSE : PI
 |
 =======================================================================*/
static	VOID	SelectLines(HWND hwnd, SHORT n, BOOL drag)
{
	RECTL	rcl, rcl2;
	SHORT	nRec, pageLine;
	SHORT	oldpSelect2, oldnSelect;

	nRec = (SHORT)DBRecCount(logDBp);
	if (nRec == 0)
		return;

	oldpSelect2 = pSelect2;
	oldnSelect = nSelect;

	WinQueryWindowRect(hwnd, &rcl);
	rcl.yTop -= gcyChar * 2;
	pageLine = (SHORT)(rcl.yTop - rcl.yBottom) / gcyChar;

	if (nSelect != 0) {
		if (pSelect2 + n < 0)
			pSelect2 = 0;
		else if (pSelect2 + n >= nRec)
			pSelect2 = nRec - 1;
		else
			pSelect2 += n;

		if (!drag) {
			rcl2 = rcl;
			rcl2.yTop -= (pSelect - pTop) * gcyChar;
			rcl2.yBottom = rcl2.yTop - nSelect * gcyChar;
			WinInvalidateRect(hwnd, &rcl2, FALSE);
			pSelect1 = pSelect2;
			oldnSelect = 0;
		}
	} else
		pSelect1 = pSelect2 = pTop;

	if (pSelect1 >= pSelect2) {
		pSelect = pSelect2;
		nSelect = pSelect1 - pSelect2 + 1;
	} else {
		pSelect = pSelect1;
		nSelect = pSelect2 - pSelect1 + 1;
	}

	rcl2 = rcl;
	rcl2.yTop -= ((nSelect >= oldnSelect ? pSelect2 : oldpSelect2) - pTop)
								* gcyChar;
	rcl2.yBottom = rcl2.yTop - gcyChar;
	WinInvalidateRect(hwnd, &rcl2, FALSE);

	if (n != 0) {
		if (pSelect2 < pTop)
			Scroll(hwnd, pSelect2 - pTop);
		else if (pSelect2 >= pTop + pageLine)
			Scroll(hwnd, pSelect2 - (pTop + pageLine - 1));
	} else
		nSelect = 0;
}

/*=======================================================================
 |
 |		XN[o[\
 |
 |	VOID	EnableScrollBar(hwnd)
 |
 |		HWND	hwnd;		EBhEnh
 |
 =======================================================================*/
static	VOID	EnableScrollBar(HWND hwnd)
{
	SWP	swp;

	WinQueryWindowPos(hwnd, &swp);
	if (pTop != 0 || swp.cy / gcyChar < (SHORT)DBRecCount(logDBp) + 2) {
		WinSendMsg(hwndSB, SBM_SETSCROLLBAR,
			MPFROMSHORT(pTop),
			MPFROM2SHORT(0, (SHORT)DBRecCount(logDBp)-1));
		WinEnableWindow(hwndSB, TRUE);
	} else
		WinEnableWindow(hwndSB, FALSE);
}

/*=======================================================================
 |
 |		vOI
 |
 |	VOID	Terminate()
 |
 =======================================================================*/
VOID	Terminate(VOID)
{
	DBCloseAll();
	remove(fnFCHECK);
}

/*=======================================================================
 |
 |		hr`lCuG[\
 |
 |	VOID	ISAMErrorProc(errCode)
 |
 |		int	errCode;	hr`lCuG[R[h
 |
 =======================================================================*/
static	VOID	ISAMErrorProc(int errCode)
{
	static	char	msg[80];

	if (errCode != IE_NOFILE) {
		sprintf(msg, "ERROR CODE = %d", errCode);
		WinPostMsg(hwndClient, WM_USER_MSGBOX, msg,
					"hr`lt@CG[");
	}
}

/*=======================================================================
 |
 |		vIG[
 |
 |	VOID	FatalError(errCode)
 |
 |		USHORT	errCode;	G[R[h
 |
 =======================================================================*/
VOID	FatalError(USHORT errCode)
{
	Terminate();
	DosExit(EXIT_PROCESS, errCode);

}

static	VOID	TerminateHelp(HWND hwnd)
{
	if (hwndHelpInstance != (HWND)NULL) {
		WinAssociateHelpInstance(NULL, hwnd);
		WinDestroyHelpInstance(hwndHelpInstance);
	}
}


static	VOID	InitHelp(HWND hFrame, HAB hab)
{
	HELPINIT stHMInit;
	BOOL	bHelpLibFound=TRUE;

	stHMInit.cb			= sizeof(HELPINIT);
	stHMInit.ulReturnCode		= 0L;
	stHMInit.pszTutorialName	= NULL;
	stHMInit.phtHelpTable		= (PHELPTABLE)(0xffff0000 |
						(LONG)PCNET_HELP_TABLE);
	stHMInit.hmodHelpTableModule	= (HMODULE)NULL;
	stHMInit.hmodAccelActionBxxxodule = (HMODULE)NULL;
	stHMInit.idAccelTable		= 0;
	stHMInit.idActionBar		= 0;

	stHMInit.pszHelpWindowTitle	= "ob|mds^Q wv";
	stHMInit.usShowPanelId		= CMIC_HIDE_PANEL_ID;
	stHMInit.pszHelpLibraryName	= "PCNET.HLP";

	if (!(hwndHelpInstance = WinCreateHelpInstance(hab, &stHMInit))) {
		if (stHMInit.ulReturnCode == HMERR_OPEN_LIB_FILE)
			DspHelpErr("wvt@C܂B");
		else
			DspHelpErr("wvCX^X쐬ł܂B");

		return;
	}

	if (!WinAssociateHelpInstance(hwndHelpInstance, hFrame)) {
		DspHelpErr("wvCX^X̊֘Atł܂B");
		return;
	}

	if (stHMInit.ulReturnCode) {
		DspHelpErr("wv}l[WG[");
		return;
	}
}


static	VOID	SendHelpMsg(USHORT usMsg)
{
	WinSendMsg(hwndHelpInstance, usMsg, NULL, NULL);
}

static	VOID	AssociateHelp(HWND hwnd)
{
	WinAssociateHelpInstance(hwndHelpInstance, hwnd);
}

static	VOID	DspHelpErr(CHAR *msg)
{
	WinMessageBox(HWND_DESKTOP,
		WinQueryActiveWindow( HWND_DESKTOP, FALSE),
		msg,
		"wṽG[",
		ID_MB,
		MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL | MB_MOVEABLE);
}
